freeslot("S_SOPHIAHEAD","MT_SOPHIAHEAD","SPR_SHED","S_SOPHIAMISSILE","MT_SOPHIAMISSILE")

local headFunc = function(mo,t,p)	
	if not (mo and t and p and mo.valid and t.valid and p.sophia)
		return 
	end
		
	mo.angle = R_PointToAngle(mo.x,mo.y)
	P_Move(mo,-1)
	mo.angle = t.angle
	mo.z = $-min(max(t.momz,-FRACUNIT*2),FRACUNIT*2)
	if p.sophia.target and p.sophia.target.valid
		local pst = p.sophia.target
		mo.angle = R_PointToAngle2(mo.x,mo.y,pst.x,pst.y)
	end
end

local dealSophiaDamage = function(targ,p)
	if targ.flags2 & MF2_FRET
	or (targ.player and (targ.player.powers[pw_flashing] or targ.player.powers[pw_invulnerability]))
		return end
	if not targ.sophiadamage
		targ.sophiadamage = 1
		S_StartSound(targ,sfx_corkh)
	elseif targ.sophiadamage < (3-p.sophia.gear)
		targ.sophiadamage = $+1
		S_StartSound(targ,sfx_corkh)
	else
		S_StartSound(targ,sfx_shattr)
		targ.sophiadamage = 0
		if targ.tracer and targ.tracer.type == MT_EGGSHIELD
			P_KillMobj(targ.tracer,nil,p.mo)
			S_StartSound(targ,sfx_wbreak)
		elseif targ.flags & MF_MONITOR
			P_KillMobj(targ,nil,p.mo)
		else
			P_DamageMobj(targ,nil,p.mo)
			P_GivePlayerRings(p,1)
		end
	end
end

local sophiaGearShift = function(p)
	local gear = p.sophia.gear
	
	if gear == 0
		p.accelstart = 64
		p.normalspeed = 32*FRACUNIT
		p.actionspd = 28*FRACUNIT
		p.jumpfactor = FRACUNIT*85/100
		p.sophia.range = 600*FRACUNIT
	elseif gear == 1
		p.accelstart = 64
		p.normalspeed = 36*FRACUNIT
		p.actionspd = 34*FRACUNIT
		p.jumpfactor = FRACUNIT
		p.sophia.range = 800*FRACUNIT
	elseif gear == 2
		p.accelstart = 96
		p.normalspeed = 36*FRACUNIT
		p.actionspd = 40*FRACUNIT
		p.jumpfactor = FRACUNIT
		p.sophia.range = 1000*FRACUNIT
	else
		p.accelstart = 128
		p.normalspeed = 40*FRACUNIT
		p.actionspd = 46*FRACUNIT
		p.jumpfactor = FRACUNIT*1355/1000
		p.sophia.range = 1200*FRACUNIT
	end
end

local sophiaShiftDown = function(p)
	S_StartSound(p.mo,sfx_kc65)
end

local sophiaShiftUp = function(p)
	S_StartSound(p.mo,sfx_kc4d)
end

local sophiaCheckGear = function(p)
	local r = p.rings
	local g = p.sophia.gear
	p.sophia.lastcheckedgear = r
	
	if r == 0
	and g != 0
		p.sophia.gear = 0
		sophiaGearShift(p)
		sophiaShiftDown(p)
	elseif g == 0
		if r >= 12
			p.sophia.gear = 1
			sophiaGearShift(p)
			sophiaShiftUp(p)
		end
	elseif g == 1
		if r < 8
			p.sophia.gear = 0
			sophiaGearShift(p)
			sophiaShiftDown(p)
		elseif r >= 24
			p.sophia.gear = 2
			sophiaGearShift(p)
			sophiaShiftUp(p)
		end
	elseif g == 2
		if r < 20
			p.sophia.gear = 1
			sophiaGearShift(p)
			sophiaShiftDown(p)
		elseif r >= 48
			p.sophia.gear = 3
			sophiaGearShift(p)
			sophiaShiftUp(p)
		end
	else
		p.sophia.gear = 3
		if r < 45
			p.sophia.gear = 2
			sophiaGearShift(p)
			sophiaShiftDown(p)
		end
	end
end

----------------------------------------------------------------------------------------------------------------------------------------------------------

addHook("PostThinkFrame",function()
	for p in players.iterate
		if p.mo and p.mo.valid and p.mo.skin == "sophia" and p.followmobj and p.followmobj.valid
			headFunc(p.followmobj,p.mo,p)
		end
	end
end)

addHook("PlayerSpawn",function(p)
	if skins[p.skin].name == "sophia"
		p.sophia = {
			target = nil,
			lastinput = nil,
			lastcheckedgear = -1,
			gear = -1,
			range = 0
		}
	end
end)

addHook("PlayerThink",function(p)
	local mo = p.mo
	
	if not (p.sophia and mo and mo.valid)
		return end
		
	if p.sophia.lastinput == nil
		p.sophia.lastinput = p.cmd.buttons
	end
	
	
	if not (p.powers[pw_strong] & STR_FLOOR)
		p.powers[pw_strong] = $|STR_FLOOR
	end
	
	if p.sophia.gear == -1
		p.sophia.gear = 0
		sophiaGearShift(p)
		p.sophia.lastcheckedgear = p.rings
	elseif p.rings != p.sophia.lastcheckedgear
		sophiaCheckGear(p)
	end
		
	local targ = nil
	local targ2 = nil
	local range = p.sophia.range
	
	searchBlockmap("objects",function(r,f)
		local objectdir = R_PointToAngle2(r.x,r.y,f.x,f.y)
		local rvec = {cos(r.angle),sin(r.angle)}
		local fvec = {2*cos(objectdir),2*sin(objectdir)}
		
		if P_CheckSight(r,f)
		and f.flags & (MF_ENEMY|MF_SHOOTABLE|MF_MONITOR)
		and f != r
		and f != r.followmobj
		and R_PointToDist2(r.x,r.y,f.x,f.y) <= range
		and (not (targ and targ.valid)
		or R_PointToDist2(r.x,r.y,f.x,f.y) < R_PointToDist2(r.x,r.y,targ.x,targ.y))
		--and fixmul(rvec[1], fvec[1]) + fixmul(rvec[2], fvec[2]) >= 0
			targ = f
		end
	end,mo,mo.x-range,mo.x+range,mo.y-range,mo.y+range)
	
	if p.sophia.gear == 3
		searchBlockmap("objects",function(r,f)
			local objectdir = R_PointToAngle2(r.x,r.y,f.x,f.y)
			local rvec = {cos(r.angle),sin(r.angle)}
			local fvec = {2*cos(objectdir),2*sin(objectdir)}
			
			if P_CheckSight(r,f)
			and f.flags & (MF_ENEMY|MF_SHOOTABLE|MF_MONITOR)
			and f != r
			and f != r.followmobj
			and f != targ
			and R_PointToDist2(r.x,r.y,f.x,f.y) <= range
			and (not (targ2 and targ2.valid)
			or R_PointToDist2(r.x,r.y,f.x,f.y) < R_PointToDist2(r.x,r.y,targ2.x,targ2.y))
			--and fixmul(rvec[1], fvec[1]) + fixmul(rvec[2], fvec[2]) >= 0
				targ2 = f
			end
		end,mo,mo.x-range,mo.x+range,mo.y-range,mo.y+range)
	end
	
	p.sophia.target = targ
	if targ and targ.valid and targ.health
		local canhittarg2 = (targ2 and targ2.valid and targ2.health)
		
		P_SpawnLockOn(p,targ,S_LOCKON1)
		if canhittarg2
			P_SpawnLockOn(p,targ2,S_LOCKON2)
		end
		
		if p.cmd.buttons & BT_SPIN
		and not (p.sophia.lastinput & BT_SPIN)
			S_StartSound(mo,sfx_corkp)
			dealSophiaDamage(targ,p)
		elseif p.cmd.buttons & BT_CUSTOM1
		and not (p.sophia.lastinput & BT_CUSTOM1)
		and p.sophia.gear
			p.rings = $-2
			P_SpawnXYZMissile(mo, targ, MT_CYBRAKDEMON_MISSILE, mo.x, mo.y, mo.z)
			if canhittarg2
				P_SpawnXYZMissile(mo, targ2, MT_CYBRAKDEMON_MISSILE, mo.x, mo.y, mo.z)
			end
		end
	end
	
	p.sophia.lastinput = p.cmd.buttons
end)

hud.add(function(v,p,cam)
	if not p.sophia
		return end
		
	local gearstring = p.sophia.gear
	if gearstring == 3
		gearstring = "Max"
	end
	
	v.drawString(310,180,"Gear " .. gearstring,V_SNAPTORIGHT|V_SNAPTOBOTTOM|V_HUDTRANS,"right")
end)